#ifndef _BUILDDESKTOPIMAGE_H_
#define _BUILDDESKTOPIMAGE_H_

#define WM_NI_MSG		(WM_USER+1)	// user defined message for the shell notify icon
#define WM_SHOWOPTIONS	(WM_USER+2)	// user defined message used to display the options window
#define WM_HIDEWINDOW	(WM_USER+3) // user defined message

class CBuildDesktopImage
{
public:
	HWND hWnd;
	CBuildDesktopImage(HWND hWnd);
	~CBuildDesktopImage(void);
	void SetHWnd(HWND hWnd);
	NOTIFYICONDATA m_tnd;			// Structure to bring in a tray Icon	
	HICON m_hCalIcon;		// Calendar Icon on Tray
	HBITMAP hBitmap;	// Desktop wallpaper bitmap
	CString m_szFontName;	// Font face name
	INT m_nFontSize;	// Font Size
	COLORREF m_crTextColor;	// Text Color
	COLORREF m_crBackColor;	// BackGround Color
	INT m_nXPos;		// Starting location X
	INT m_nYPos;		// Starting location Y
	INT m_nTransparency; // Transparency
	INT nVirtualScreenWidth;
	INT nVirtualScreenHeight;
	HDC hMemDC;
	HDC hDC;
	BOOL m_nBackgroundTransparency;	// Background Transparency
	CString Language;
public:
	HBITMAP LoadImage(CString szFile, long& nWidth, long& nHeight);
	BOOL SaveBitmap(HDC hDC, HBITMAP hBitmap, CString szPath);
	void StartBitmap();
	void SetImage(CString img, int style, int monitor);
	void StopBitmap();
	void ReadRegistry();
	void WriteRegistry();
	void SetIcon();
	int CheckDate();
	static BOOL CALLBACK AddMonitorsCallBack(HMONITOR hMonitor, // handle to display monitor
		HDC hdcMonitor, // handle to monitor DC
		LPRECT lprcMonitor, // monitor intersection rectangle
		LPARAM dwData   	// data
	);
	CObArray m_MonitorArray;
	typedef struct tagADDMONITOR
	{
		CObArray* pMonitors;
		int currentIndex;
	} ADDMONITOR, * LPADDMONITOR;
};

#ifndef _CMONITOR_H_
#define _CMONITOR_H_
// CMonitor 

class CMonitor : public CObject
{
public:
	//construction destruction
	CMonitor();
	CMonitor(const CMonitor& monitor);
	virtual ~CMonitor();

	//operations
	void Attach(const HMONITOR hMonitor);
	HMONITOR Detach();

	//properties
	void GetMonitorRect(LPRECT lprc) const;
	//operators
	operator HMONITOR() const
	{
		return this == NULL ? NULL : m_hMonitor;
	}

	BOOL operator ==(const CMonitor& monitor) const
	{
		return m_hMonitor == (HMONITOR)monitor;
	}

	BOOL operator !=(const CMonitor& monitor) const
	{
		return !(*this == monitor);
	}

	void operator =(const CMonitor& monitor)
	{
		m_hMonitor = (HMONITOR)monitor;
	}


private:
	HMONITOR m_hMonitor;
};
#endif
#endif
