// WallpaperQDlg.h : header file
//

#pragma once
#include "resource.h"
#include "afxwin.h"
#include "afxtempl.h"
#include "afxcmn.h"
#include "shlobj.h"
#include "buildDesktopImage.h"
#include "clock.h"

using namespace Gdiplus;

// CWallpaperQDlg dialog
class CWallpaperQDlg : public CDialog
{
	// Construction
public:
	CWallpaperQDlg();	// standard constructor
	virtual ~CWallpaperQDlg();
	CComboBox m_comboPosition;	/* How the wallpaper is displayed. */

	// Dialog Data
	enum
	{
		IDD = IDD_WALLPAPERQ_DIALOG
	};
	CString m_szFontName;
	INT m_nFontSize;
	COLORREF m_crTextColor;
	COLORREF m_crBackColor;
	UINT m_uXPos;
	UINT m_uYPos;
	int m_nTransparency;
	BOOL m_nBackgroundTransparency;
	void DrawText();
	void translate();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	CListBox m_lbBrowseList;	/* List of images in the browsed to folder. */
	CWnd m_picPreview;			/* Preview window. */
	CStatic m_stType;			/* BitsPerPixel of the image. */
	CStatic m_stHeight;			/* Height of the image in pixels. */
	CStatic m_stWidth;			/* Width of the image in pixels. */
	CStatic m_stResolution;		/* Screen resolution. */
	CStatic m_stColors;			/* Number of screen colors. */
	CEdit m_edLookIn;			/* Edit box holding the browse path. */
	CListBox m_lbQList;			/* Queued image list box. */
	CButton m_chkRandomize;		/* Randomize checkbox. */
	CButton m_btnApply;			/* Apply button. */
	CButton m_btnArrowUp;		/* Move image up button */
	CButton m_btnArrowDown;		/* Move image down button */
	CButton m_btnHideshowIcons;
	CButton m_btnSetCurrent;
	CBuildDesktopImage* m_buildDesktopImage;
	CClock* clock;

	afx_msg void OnLbnSelchangeBrowselist();
	afx_msg void OnLbnSelchangeQlist();
	afx_msg void OnStnClickedBrowse();
	afx_msg void OnBnClickedAdd();
	afx_msg void OnEnChangeLookin();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedQlistempty();
	afx_msg void OnCbnSelchangePosition();
	afx_msg void OnBnClickedApply();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBnClickedArrowup();
	afx_msg void OnBnClickedArrowdown();
	afx_msg void OnBnClickedRemoveselected();
	afx_msg void OnBnClickedRandomize();
	afx_msg void OnBnClickedHideshowicons();
	afx_msg void OnBnClickedSetCurrent();
	afx_msg void OnSetToNextImage();
	afx_msg LRESULT OnNotifyIconMsg(WPARAM wParam, LONG lParam);
	afx_msg LRESULT OnShowOptions(WPARAM wParam, LONG lParam);
	afx_msg LRESULT OnHideMainWindow(WPARAM wParam, LONG lParam);

	// Implementation
protected:
	HICON m_hIcon;

	CString cstrAppPath;
	CString cstrBrowsePath;
	int iCurrentImage, iStartup, iThisUser, iExitAfter, iUseTimer, iMinutes, iUpdate, iDisplayClock;
	RECT rcLastSize;
	IActiveDesktop* pIActiveDesktop;
	NOTIFYICONDATA niData;
	UINT uiTimer;
	BOOL bIconsShown;
	HMODULE hAOT;
	void ResetMainDialog();
	void FillList();
	void DrawPreview();
	void SetBrowsePath(CString cstrPath)
	{
		cstrBrowsePath = cstrPath;
	};
	void FillQueuedImages();
	void ApplyChanges(BOOL bChangeWallpaper = TRUE);
	void ChangeWallpaper(int iMode);
	void OnShowConfigWindow();
	void OnAbout();
	void OnOptions();
	void OnExit();
	afx_msg void OnFontBtn();
	afx_msg void OnColorBtn();
	afx_msg void OnEnChangeXpos();
	afx_msg void OnEnChangeYpos();
	afx_msg void OnBnClickedBackgroundtransparency();
	CString GetBrowsePath()
	{
		return cstrBrowsePath;
	};
	int GetWPPositionByImageSize(CString cstrImagePath);
	void MinimizeAllWindows(BOOL bMinimize = TRUE);

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();

	DECLARE_MESSAGE_MAP()
};
